using System;

namespace LazyCaching
{
	/// <summary>
	/// Should be implemented by all cachable business objects, this will contain all methods
	/// used to drive cached execution.
	/// </summary>
	public interface ICached
	{
		void ExecuteCached();
	}
}
