using System;

namespace AbstractCache
{
	/// <summary>
	/// Should be implemented by all cachable business objects, method name can change depending
	/// on the kind of data that will be cached.
	/// </summary>
	public interface ICacheable
	{
		void PrepareConfigData();
		void PrepareWorkers();
	}
}
