using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.Services;

namespace WebServiceInterface
{
	interface ICanBeAnyInterface 
	{
		// any signature can be used
		int ExecuteA();
		int ExecuteB();
	}

	/// <summary>
	/// Summary description for Service1.
	/// </summary>
	[WebService(Name = "ICanBeAnyInterface", Namespace="http://www.etier.com/patterns.net",
	Description = "This web service is abstract and cannot be directly called.")]
	abstract class WebServiceInterface : ICanBeAnyInterface
	{
		[WebMethod(Description = "Defines as a WebService Interface ExecuteA from ICanBeAnyInterface")]
		abstract public int ExecuteA();
            
		[WebMethod(Description = "Defines as a WebService Interface ExecuteB from ICanBeAnyInterface")]
		abstract public int ExecuteB();
    }
}
