VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Fault Client"
   ClientHeight    =   4200
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   9450
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4200
   ScaleWidth      =   9450
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkCustomSoap 
      Caption         =   "&Custom Soap"
      Height          =   255
      Left            =   8040
      TabIndex        =   6
      Top             =   720
      Value           =   1  'Checked
      Width           =   1335
   End
   Begin VB.ComboBox cbWSDL 
      Height          =   315
      ItemData        =   "Main.frx":0000
      Left            =   120
      List            =   "Main.frx":0007
      TabIndex        =   5
      Top             =   720
      Width           =   7515
   End
   Begin VB.TextBox txtResult 
      Height          =   2655
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   3
      Top             =   1440
      Width           =   9195
   End
   Begin VB.CheckBox chkWantFault 
      Caption         =   "Want Fault"
      Height          =   255
      Left            =   8040
      TabIndex        =   2
      Top             =   960
      Value           =   1  'Checked
      Width           =   1215
   End
   Begin VB.CommandButton cmdDoIt 
      Caption         =   "Execute"
      Height          =   375
      Left            =   7800
      TabIndex        =   0
      Top             =   120
      Width           =   1515
   End
   Begin VB.Label Label2 
      Caption         =   "Error Output:"
      Height          =   195
      Left            =   120
      TabIndex        =   4
      Top             =   1200
      Width           =   975
   End
   Begin VB.Label Label1 
      Caption         =   "WSDL:"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   615
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdDoIt_Click()

    Dim sc As SoapClient
    Dim S As String
    Dim bUseCustomSoap As Boolean
    
    txtResult.Text = ""
    txtResult.Refresh
    
    On Error Resume Next
    
    Set sc = New SoapClient
    sc.mssoapinit cbWSDL.Text
    
    If sc.detail <> "" Then
        MsgBox "SoapClient.mssoapinit failed. " & sc.detail
        Exit Sub
    End If
    
    bUseCustomSoap = IIf(chkCustomSoap.Value = 1, True, False)
    S = sc.ThrowAnException(bUseCustomSoap)
    
    Dim Result As String
    
    If Err Then
    
        If chkWantFault.Value <> vbChecked Then
            Result = Result & "**** Recieved Unexpected Error ****" & vbCrLf & vbCrLf
        End If
        
        Result = Result & "Err.Number=" & Err.Number & vbCrLf
        Result = Result & "Err.Description=""" & Err.Description & """" & vbCrLf
        Result = Result & "Err.HelpContext=""" & Err.HelpContext & """" & vbCrLf
        Result = Result & "Err.HelpFile=""" & Err.HelpFile & """" & vbCrLf
        Result = Result & "Err.Source=""" & Err.Source & """" & vbCrLf
        Result = Result & "SoapClient.faultcode=""" & sc.faultcode & """" & vbCrLf
        Result = Result & "SoapClient.faultstring=""" & sc.faultstring & """" & vbCrLf
        Result = Result & "SoapClient.faultactory=""" & sc.faultactor & """" & vbCrLf
        Result = Result & "SoapClient.detail=""" & sc.detail & """" & vbCrLf
        
    Else
    
        If chkWantFault.Value = vbChecked Then
            Result = Result & "**** Did Not Recieve Expected Error ****" & vbCrLf & vbCrLf
        End If
        
        Result = Result & "MakeFault=" & S & vbCrLf
        
    End If

    txtResult.Text = Result
        
End Sub

Private Sub Form_Load()

    cbWSDL.AddItem "http://localhost/dotnetpatterns/exceptionhandling/exceptionthrower.asmx?wsdl"
    cbWSDL.Text = "http://localhost/dotnetpatterns/exceptionhandling/exceptionthrower.asmx?wsdl"
    
End Sub
