using System;

namespace Calc
{
	/// <summary>
	/// Summary description for Add.
	/// </summary>
	public class Subtract : TestBed.ITestable
	{
		public int Execute(int Val1, int Val2)
		{
			return Val1 - Val2;
		}

		#region ITestable Interface
		/// <summary>
		/// Will be used to generate random numbers
		/// </summary>
		private Random r = new Random();

		public System.Collections.SortedList GetTestParameters()
		{
			System.Collections.SortedList list = new System.Collections.SortedList();
			list.Add("Value1", typeof(int));
			list.Add("Value2", typeof(int));
			return list;
		}
		public System.Collections.SortedList[] GetTestSet(int Count)
		{
			System.Collections.SortedList[] alist = new System.Collections.SortedList[Count];

			for (int i=0; i < Count; i++)
			{
				alist[i] = new System.Collections.SortedList();
				alist[i].Add("Value1", r.Next());
				alist[i].Add("Value2", r.Next());
			}
			return alist;
		}
		public bool Test(ref System.Collections.SortedList Parameters)
		{
			int val1 = int.Parse(Parameters["Value1"].ToString());
			int val2 = int.Parse(Parameters["Value2"].ToString());
			Parameters.Add("Result", this.Execute(val1, val2));
			return true;
		}
		#endregion 
	
	}
}
