using System;
using System.Text;
using DataTierPatterns.Data;

namespace DataTierPatterns.Data
{
	/// <summary>
	/// </summary>
	public abstract class PolyModelWhere
	{	
		protected string m_sSQL = string.Empty;

		public PolyModelWhere()
		{

		}


		public string SQL
		{
			get 
			{	
				return m_sSQL; 
			}	
		}	


		public void Clear()
		{
			m_sSQL = string.Empty;
		}	
				

		public abstract void WhereEqual(string sKey, string sValue);
	}
}
